#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_port.h>
#include <p32mx/interrupt.h>
#include <p32mx/timer.h>

// Olimex PIC32-PINGUINO-MX220 
//    LED1 (Green) D13 = RB15 Active H (1: Light on)
//    LED2 (Red  ) D9  = RA10 Active H (1: Light on)
//    BUT          D8  = RB7  Active L (0 : Pressed)

void timer_entry()
{
	LAT_SET(0)  = 1 << 10;
}

int main() {
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_clr(LAT , 1, 15);
	regx_clr(LAT , 0, 10);
	interrupt_enable();

	timer_callback = timer_entry;
	//timer_start(100);
	//__timer_start(3, 50000);  // 40M / 8 / 50000 = 100
	__timer_start(7, 50000);  // 40M / 256 / 50000 = 100/32 (Hz)
	regx_set(LAT , 1, 15);
	for (;;) {
		delay_us(500000); // 0.5 sec 
		regx_inv(LAT , 1, 15);
	}
}
