#ifndef _JZ_P32MX_SPI_H_
#define _JZ_P32MX_SPI_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _spi_base_addr	(_sfrs_base_addr_0 + 0x5800)
#else
  #define _spi_base_addr	((const void *)0xBF805800)
#endif

#define _SPI_ADDR(x)	(_spi_base_addr + (x)*0x200)

  /* x=0: SPI1 x=1:SPI2 */
  #define SPI_CON(x)          (*(volatile unsigned *)(_SPI_ADDR(x) + 0x00))
  #define SPI_CON_CLR(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x04))
  #define SPI_CON_SET(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x08))
  #define SPI_CON_INV(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x0C))

  #define SPI_STAT(x)         (*(volatile unsigned *)(_SPI_ADDR(x) + 0x10))
  #define SPI_STAT_CLR(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x14))
  #define SPI_STAT_SET(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x18))
  #define SPI_STAT_INV(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x1C))

  #define SPI_BUF(x)          (*(volatile unsigned *)(_SPI_ADDR(x) + 0x20))

  #define SPI_BRG(x)          (*(volatile unsigned *)(_SPI_ADDR(x) + 0x30))
  #define SPI_BRG_CLR(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x34))
  #define SPI_BRG_SET(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x38))
  #define SPI_BRG_INV(x)      (*(volatile unsigned *)(_SPI_ADDR(x) + 0x3C))

  #if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define SPI_CON2(x)         (*(volatile unsigned *)(_SPI_ADDR(x) + 0x40))
  #define SPI_CON2_CLR(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x44))
  #define SPI_CON2_SET(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x48))
  #define SPI_CON2_INV(x)     (*(volatile unsigned *)(_SPI_ADDR(x) + 0x4C))
  #endif

    #define SPI_CON_SRXISEL                0x00
    #define SPI_CON_STXISEL                0x02
    #define SPI_CON_DISSDI                 0x04
    #define SPI_CON_MSTEN                  0x05
    #define SPI_CON_CKP                    0x06
    #define SPI_CON_SSEN                   0x07
    #define SPI_CON_CKE                    0x08
    #define SPI_CON_SMP                    0x09
    #define SPI_CON_MODE16                 0x0A
    #define SPI_CON_MODE32                 0x0B
    #define SPI_CON_DISSDO                 0x0C
    #define SPI_CON_SIDL                   0x0D
    #define SPI_CON_ON                     0x0F
    #define SPI_CON_ENHBUF                 0x10
    #define SPI_CON_SPIFE                  0x11
    #define SPI_CON_MCLKSEL                0x17
    #define SPI_CON_FRMCNT                 0x18
    #define SPI_CON_FRMSYPW                0x1B
    #define SPI_CON_MSSEN                  0x1C
    #define SPI_CON_FRMPOL                 0x1D
    #define SPI_CON_FRMSYNC                0x1E
    #define SPI_CON_FRMEN                  0x1F
    #define SPI_STAT_SPIRBF                0x00
    #define SPI_STAT_SPITBF                0x01
    #define SPI_STAT_SPITBE                0x03
    #define SPI_STAT_SPIRBE                0x05
    #define SPI_STAT_SPIROV                0x06
    #define SPI_STAT_SRMT                  0x07
    #define SPI_STAT_SPITUR                0x08
    #define SPI_STAT_SPIBUSY               0x0B
    #define SPI_STAT_FRMERR                0x0C
    #define SPI_STAT_TXBUFELM              0x10
    #define SPI_STAT_RXBUFELM              0x18
    #define SPI_CON2_AUDMOD                0x00
    #define SPI_CON2_AUDMONO               0x03
    #define SPI_CON2_AUDEN                 0x07
    #define SPI_CON2_IGNTUR                0x08
    #define SPI_CON2_IGNROV                0x09
    #define SPI_CON2_SPITUREN              0x0A
    #define SPI_CON2_SPIROVEN              0x0B
    #define SPI_CON2_FRMERREN              0x0C
    #define SPI_CON2_SPISGNEXT             0x0F
    #define SPI_CON2_AUDMOD0               0x00
    #define SPI_CON2_AUDMOD1               0x01
#endif /* _JZ_P32MX_SPI_H_ */
